
#property indicator_chart_window 
#property indicator_buffers 2 

#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_width1 1
#property indicator_width2 1

extern int EMA_Period1 = 35, EMA_Period2 = 26, EMA_Price = PRICE_CLOSE;
extern bool Colored = true;
double TS[], buff[], TS_1[];

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
   IndicatorBuffers(4);  

   IndicatorShortName("DEMA ("+EMA_Period1+","+EMA_Period2+")"); 
    
   SetIndexBuffer(0, TS);
   SetIndexBuffer(1, TS_1);
   SetIndexBuffer(2, buff); 
   
   SetIndexStyle(0, DRAW_LINE); 
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexEmptyValue(1, 0);
   
   SetIndexDrawBegin(0, 2); 
   SetIndexDrawBegin(1, 2);
   SetIndexLabel(0, "DEMA");   
              
   return(0); 
  } 


int deinit() 
{ 
   return(0); 
}

int start()
{ 
   int i, limit, counted_bars=IndicatorCounted(); 
               

//---- check for possible errors
   if(counted_bars<0) return(-1); 

//---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 

   limit=Bars-counted_bars; 

   for(i=limit-1; i>=0; i--) buff[i] = iMA(NULL, 0, EMA_Period1, 0, MODE_EMA, EMA_Price, i);   
   for(i=limit-1; i>=0; i--) TS[i] = iMAOnArray(buff, 0, EMA_Period2, 0, MODE_EMA, i);
   
   if(Colored){
     for(i=0; i<limit; i++){
       if(TS[i] < TS[i+1]) TS_1[i] = TS[i];
       else TS_1[i] = 0;
       if(TS[i+1] >TS[i+2]) TS_1[i] = 0;
     }
   }

   return(0); 
  } 


